*" PACKAGE AADMIN !"  ᥤ롼
*"                  ver 1.00             92/10/13 takepiro
*"                  ver 1.90             99/11/12 takepiro æ GTOOL 
***********************************************************************
      PROGRAM GAMRAS                           !" ᥤ롼
*
*"    Boussinesq ǥ
*"      one-level time integration
*
      IMPLICIT NONE
*
*   [PARAM]
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zhdim.F"                    !" ʸʸ
#include        "zccom.F"                    !" ɸʪ
*
*   [VAR]
      REAL       GAU   ( IDIM, JDIM, 0:KMAX )  !"    
      REAL       GAV   ( IDIM, JDIM, 0:KMAX )  !"    
      REAL       GAW   ( IDIM, JDIM, 0:KMAX )  !" ľ 
      REAL       GAT   ( IDIM, JDIM, 0:KMAX )  !"    
      REAL       GATOR ( IDIM, JDIM, 0:KMAX )  !" ȥ 
      REAL       GAPOR ( IDIM, JDIM, 0:KMAX )  !" ݥ 
*
*"    COMMON /COMCON/ ( include ZCCOM )
*     REAL       ERI                          !" 
*     REAL       ERO                          !" 
*     REAL       ETA                          !" /
*"    COMMON /COMCON/ end
*"       : ʪѥ᡼
*
*"       : ɸ
      REAL       ALAT  ( JDIM )        !" 
      REAL       DLAT  ( JDIM )        !" ٲٽ
      REAL       ALON  ( IDIM )        !" 
      REAL       DLON  ( IDIM )        !" ٲٽ
      REAL       ARAD  ( 0:KMAX )      !" ٥()
      REAL       DRAD  ( 0:KMAX )      !" ()
*
*"       : ֥ƥåץѥ᡼
      INTEGER    IT             !" 롼ץ
      CHARACTER  HINTG * (NCC)  !" ʬå
      LOGICAL    OOUT           !" ϥå
      LOGICAL    OEND           !" λå
      INTEGER    IUNIT          !" åֹ
      REAL       DELT           !" ֹ
*
*   [WORK]
      COMMON    /COMWRK/ WORK
      REAL       WORK  ( NWORK )       !" ΰ
*
*
*" << SETPUP :  >>
*
      CALL GLPGET( 'MSGUNIT', IUNIT )
      WRITE ( IUNIT, * ) ' 3-DIM BOUSSINESQ MODEL GAMRAS'
     &                   //NAME
     &                   //' ver.1.9, 99/11/12'
*
      CALL CLCSTR ( 'SETUP' )
      CALL YPREP                       !" ƥ 
*
      CALL ATSTRT                      !" ¸()
     O     ( IT , DELT ) 
*
      CALL ACRGET                      !" ɸ
     O         ( ALON  , DLON  ,
     O           ALAT  , DLAT  ,
     O           ARAD  , DRAD   )
*
      CALL IHSTRT                      !" Ϥ
*
      CALL RDSTRT                      !" ͤɤ߹ߤȺ
     I           ( IT    ,
     O             GAU   , GAV   , GAW   , GAT   , 
     O             GATOR , GAPOR )
*
      CALL ADMXMN 
     I         ( GAU   , GAV   , GAW   , GAT   , 
     I           GATOR , GAPOR , IT    , 'start GA'      )
*
      CALL CLCEND ( 'SETUP' )
*
*  << LOOP : <************* ᥤ󡦥롼 >>
*
 8888 CONTINUE
*
#ifdef DEBUG
         CALL ADMXMN 
     I         ( GAU   , GAV   , GAW   , GAT   , 
     I           GATOR , GAPOR , IT    , 'begin LOOP'    )
#endif
c$$$         ISTEP = ISTEP + 1
*
*     << START : ƥåפϤν >>
*
         CALL CLCSTR ( 'TIMCON' )
*
*"        < 1. ֥ƥå >
*
          CALL ATSTEP               !"   
     M         ( IT   ,     
     O           HINTG , OOUT , OEND )
*
         CALL CLCEND ( 'TIMCON' )
*
*"    << INTEGR : ʬ >>
* 
         CALL CLCSTR ( 'DYNMCS' )
*
         CALL DYNMCS                   !" ϳعȻʬ
     M         ( GAU   , GAV   , GAW   , GAT   , 
     M           GATOR , GAPOR , 
     I           IT    , DELT  , 
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           ARAD  , DRAD                    )
*
         CALL CLCEND ( 'DYNMCS' )
*
#ifdef DEBUG
         CALL ADMXMN 
     I         ( GAU   , GAV   , GAW   , GAT   , 
     I           GATOR , GAPOR , IT    , 'after DYNMCS'    )
*
         CALL WRRSTR                !" ꥹȥե񤭹
     I          ( GAU   , GAV   , GAW   , GAT   , 
     I            GATOR , GAPOR , 
     I            IT                    )
#endif
*
*"    << NEXT : Υƥåפ >>
*
         CALL CLCSTR ( 'MISC' )
*
         IF ( OOUT ) THEN
            CALL WRRSTR                !" ꥹȥե񤭹
     I         ( GAU   , GAV   , GAW   , GAT   , 
     I           GATOR , GAPOR ,
     I           IT                               )
         ENDIF
*
         CALL CLCEND ( 'MISC' )
*
*" << LEND : ᥤ󡦥롼׽ *************> >>
*
      IF ( .NOT. OEND ) GOTO 8888    !" << LEND : ᥤ󡦥롼׽ ****> >>
*
      CALL ADMXMN 
     I      ( GAU   , GAV   , GAW   , GAT   , 
     I        GATOR , GAPOR , IT    , 'end PROGRAM'    )

      CALL IHEND                       !" Ϥκǽ
*
      CALL CLCOUT                      !" CPUֽ
      CALL YFINE                       !" ƥ
*
      STOP
      END
*************************************************************************
      SUBROUTINE ADMXMN        !" debug monitor
     I         ( GDU   , GDV   , GDW   , GDT   , 
     I           GDTOR , GDPOR , IT    , HLABEL          )
*
*   [PARAM]
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻ, ȿ
#else
#include        "zcdim.F"                    !" ʻ, ȿ
#endif
*
*   [INPUT] 
      REAL       GDU   ( IDIM, JDIM, KDIM )  !"    
      REAL       GDV   ( IDIM, JDIM, KDIM )  !"    
      REAL       GDW   ( IDIM, JDIM, KDIM )  !" ľ 
      REAL       GDT   ( IDIM, JDIM, KDIM )  !"    
      REAL       GDTOR ( IDIM, JDIM, KDIM )  !" ȥ 
      REAL       GDPOR ( IDIM, JDIM, KDIM )  !" ݥ 

*
      INTEGER    IT
      CHARACTER  HLABEL *(*)
*
      WRITE ( 6,* ) HLABEL, ' IT= ', IT
      CALL MAXMIN( GDU,   IDIM, JDIM, KDIM, IDIM, JDIM, 'U'   )
      CALL MAXMIN( GDV,   IDIM, JDIM, KDIM, IDIM, JDIM, 'V'   )
      CALL MAXMIN( GDW,   IDIM, JDIM, KDIM, IDIM, JDIM, 'W'   )
      CALL MAXMIN( GDT,   IDIM, JDIM, KDIM, IDIM, JDIM, 'T'   )
      CALL MAXMIN( GDTOR, IDIM, JDIM, KDIM, IDIM, JDIM, 'TOR' )
      CALL MAXMIN( GDPOR, IDIM, JDIM, KDIM, IDIM, JDIM, 'POR' )
*
      RETURN
      END
