* PACKAGE LADMN  !" $B@~7ANO3X8GM-CM2r@O(B
*"                  ver 1.05    93/07/14 takepiro
*"                              95/06/21 takepiro $B=PNO8GM-4X?t7W;;?tF3F~(B
*"                  ver 1.90    99/11/12 takepiro HISTORY $B=PNO30$9(B
**********************************************************************
      SUBROUTINE LANAL                      !"  $B@~7ANO3X2r@O(B
     O             ( GAU   , GAV   , GAW   , GAT   ,
     O               GATOR , GAPOR , 
     O               GRMAX , FREQ  , 
     I               MFIX  , 
     I               RAYL  , TAU   , PRND  , 
     I               ORSTR , MODE  , 
     C               ALON  , DLON  , ALAT  , DLAT  ,
     C               ARAD  , DRAD                    )
*
      IMPLICIT NONE
*
*   [PARAM]
#include        "zcdim.F"                    !" $B3J;RE@?t(B, $BGH?t(B
#include        "zldim.F"                    !" $B%Q%i%a%?!<?t(B, $B78?t9TNs(B
#include        "zccom.F"                    !" $BI8=`J*M}Dj?t(B
*
*   [OUTPUT]
      REAL       GAU   ( IDIM, JDIM, 0:KMAX )  !" $B@>Iw(B   $B#u(B
      REAL       GAV   ( IDIM, JDIM, 0:KMAX )  !" $BFnIw(B   $B#v(B
      REAL       GAW   ( IDIM, JDIM, 0:KMAX )  !" $B1tD>Iw(B $B#w(B
      REAL       GAT   ( IDIM, JDIM, 0:KMAX )  !" $B29EY(B   $B#T(B
      REAL       GATOR ( IDIM, JDIM, 0:KMAX )  !" $B%H%m%$%@%k(B $B&7(B
      REAL       GAPOR ( IDIM, JDIM, 0:KMAX )  !" $B%]%m%$%@%k(B $B&5(B
*"       : $B3J;RE@%G!<%?(B(t) <DYNMCS>  $B3J;RE@%G!<%?(B(t+$B&$(Bt)
*
      REAL       GRMAX                       !" $B@.D9N((B
      REAL       FREQ                        !" $B?6F0?t(B
*
*   [INPUT]
      REAL       ALON  ( IDIM )              !" $B7PEY(B
      REAL       DLON  ( IDIM )              !" $B7PEY2Y=E(B
      REAL       ALAT  ( JDIM )              !" $B0^EY(B
      REAL       DLAT  ( JDIM )              !" $B0^EY2Y=E(B
      REAL       ARAD  ( 0:KMAX )            !" $B#r%l%Y%k(B($B@0?t(B)
      REAL       DRAD  ( 0:KMAX )            !" $B&$#r(B($B@0?t(B)
*"        : $B:BI83J;R(B
*
      REAL       RAYL                        !" $B%l%$%j!<?t(B
      REAL       TAU                         !" $B"e%F%$%i!<?t(B
      REAL       PRND                        !" $B%W%i%s%I%k?t(B
*
      INTEGER    MFIX                        !" $BEl@>GH?t(B
*
      LOGICAL    ORSTR                       !" $B8GM-4X?t=PNO$9$k$+H]$+(B
      INTEGER    MODE                        !" $B=PNO8GM-4X?t$N%b!<%IHV9f(B
*                                            !" ( 1 $B$G:GBg@.D9N((B )
*
*   [INTERNAL SAVE]
*
*   [INTERNAL ONCE]
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX ) !" $B%9%Z%/%H%k$NE:;z=gHV(B
      REAL       FLAPLA( NMDIM  )            !" $B%i%W%i%7%"%s$N78?t(B
      REAL       EDEL  ( NMDIM  )            !" $B&F!$#D"*#U!$#V(B
*
      REAL       UVFACT ( IDIM, JDIM )       !" u$B"*(BU $B$N%U%!%/%?!<(B
*
      SAVE       NMO   , FLAPLA, EDEL  ,
     &           UVFACT
*
      LOGICAL    OSETC , OFIRST
      DATA       OSETC , OFIRST  / .FALSE., .TRUE.  /
      SAVE       OSETC , OFIRST
*
      LOGICAL    OATOR , OAPOR , OAT         !" $B2r@OBP>]J*M}NL(B
      SAVE       OATOR , OAPOR , OAT
*
*   [INTERNAL WORK]
      REAL       COFMTX( MATDMX , MATDMX )   !" $B78?t9TNs(B
      REAL       GROWTH( MATDMX )            !" $B@.D9N((B($B8GM-CM<B?tIt(B)
      REAL       FRQENC( MATDMX )            !" $B?6F0?t(B($B8GM-CM5u?tIt(B)
*
      REAL       EIGVCR( MATDMX, NVDIM )     !" $B8GM-%Y%/%H%k<B?tIt(B
      REAL       EIGVCI( MATDMX, NVDIM )     !" $B8GM-%Y%/%H%k5u?tIt(B
*
      INTEGER    NMKMTX ( NMDIM, 0:KMAX, 3 ) !" $B78?t9TNs$NE:$(;z(B
      INTEGER    NMKDIM                      !" $B78?t9TNs$N:GBgE:$(;z(B
      INTEGER    NMTLST  ( NMDIM )           !" MFIX $B@.J,%j%9%H(B($B%H%m%$%@%k(B)
      INTEGER    NMPLST  ( NMDIM )           !" MFIX $B@.J,%j%9%H(B($B%]%m%$%@%k(B)
      INTEGER    NMQLST  ( NMDIM )           !" MFIX $B@.J,%j%9%H(B($B29EY(B)
      INTEGER    NMTMAX                      !" NMTLST $B$N:GBgE:$(;z(B
      INTEGER    NMPMAX                      !" NMPLST $B$N:GBgE:$(;z(B
      INTEGER    NMQMAX                      !" NMQLST $B$N:GBgE:$(;z(B
      INTEGER    NUMEIG                      !" $B8GM-CM$N?t(B
*
      INTEGER    IERR                        !" $B%5%V%k!<%A%s%(%i!<%3!<%I(B
*"       : $B8GM-CM7W;;MQ9TNs(B
*
      INTEGER    IUNIT                       !" $BI8=`=PNOAuCVHV9f(B
*
c$$$      COMMON     /COMWRK/ EIGVCR , EIGVCI
*
*"  << SETCON : $BDj?t@_Dj(B >>
*
      IF ( MODE .GT. NVDIM ) THEN
         CALL MSGDMP( 'E', 'LADMN', 'MODE NUMBER IS TOO LARGE' )
      ENDIF
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" $B%9%Z%/%H%kDj?t@_Dj(B
     O         ( NMO   , FLAPLA, EDEL  , UVFACT, 
     C           ALAT  , DLAT                      )
      ENDIF
*   [ONCE]
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL LSTPHS                         !" $B2r@OBP>]J*M}NL$N@_Dj(B
     O         ( OATOR  , OAPOR  , OAT  )
      ENDIF
*
*" << $B78?t9TNs$N7W;;(B >>
*
      CALL CLCSTR( 'LSTMTX' )
*
      CALL MKMLST
     O      ( NMKMTX , NMKDIM ,
     O        NMTLST , NMTMAX , 
     O        NMPLST , NMPMAX , 
     O        NMQLST , NMQMAX , 
     F        OATOR  , OAPOR  , OAT   , 
     I        NMO    , MFIX             )
*
      CALL LSTMTX
     O      ( COFMTX ,
     I        NMKMTX , NMKDIM , 
     I        NMTLST , NMTMAX , 
     I        NMPLST , NMPMAX , 
     I        NMQLST , NMQMAX , 
     I        RAYL   , TAU    , PRND   ,
     F        OATOR  , OAPOR  , OAT    , 
     C        NMO    , FLAPLA , 
     C        ARAD   , DRAD                       )
*
      CALL CLCEND( 'LSTMTX' )
*
*" << $B8GM-CM7W;;(B >>
*
      CALL CLCSTR( 'LEIGEN' )
*
      CALL LEIGEN
     M        ( COFMTX , 
     O          GROWTH , FRQENC ,
     O          EIGVCR , EIGVCI ,
     O          IERR   , 
     I          NMKDIM , .TRUE. , NVDIM     )
*
      IF( IERR .NE. 0 )THEN
         CALL MSGDMP( 'W', 'LADMN', 'ERROR OCCURED AT ' )
         CALL GLPGET( 'MSGUNIT', IUNIT )
         WRITE ( IUNIT, * ) 'Rayleigh Number = ', RAYL
         WRITE ( IUNIT, * ) 'Taylor Number   = ', TAU**2
         WRITE ( IUNIT, * ) 'Prandtl Number  = ', PRND
         WRITE ( IUNIT, * ) 'E-W Wave Numver = ', MFIX
      ENDIF
*
      CALL CLCEND( 'LEIGEN' )
*
      IF ( MFIX .NE. 0 )THEN
         CALL LSLFRQ
     M         (  GROWTH , FRQENC ,
     M            EIGVCR , EIGVCI ,
     O            NUMEIG ,
     I            NMKDIM , NVDIM      )
      ELSE
         NUMEIG = NMKDIM
      ENDIF
*
*" << $B8GM-CM?GCG=PNO(B >>
*
c$$$      CALL CLCSTR( 'LDIAG' )
c$$$*
c$$$      CALL LDIAG
c$$$     I      (  GROWTH , FRQENC , 
c$$$     I         EIGVCR , EIGVCI ,
c$$$     I         NMKMTX , NUMEIG , NVDIM  ,
c$$$     I         NMTLST , NMTMAX , 
c$$$     I         NMPLST , NMPMAX , 
c$$$     I         NMQLST , NMQMAX , 
c$$$     F         OATOR  , OAPOR  , OAT    ,
c$$$     C         NMO    , FLAPLA , UVFACT , 
c$$$     C         ARAD   , DRAD   ,
c$$$     W         GAU    , GAV    , GAW    , GAT   ,
c$$$     W         GATOR  , GAPOR  )
c$$$*
c$$$      CALL CLCEND( 'LDIAG' )
*
*" << $B8GM-4X?t7W;;(B >>
*
      CALL CLCSTR( 'LEIVEC' )
*
      GRMAX = GROWTH( MODE )
      FREQ  = FRQENC( MODE )
*
      IF ( ORSTR ) THEN
         CALL LEIVEC
     O       ( GAU    , GAV    , GAW    , GAT    ,
     O         GATOR  , GAPOR  , 
     I         EIGVCR(1,MODE) , EIGVCI(1,MODE) ,
     I         NMKMTX , 
     I         NMTLST , NMTMAX , 
     I         NMPLST , NMPMAX , 
     I         NMQLST , NMQMAX , 
     F         OATOR  , OAPOR  , OAT    ,
     C         NMO    , FLAPLA , UVFACT , 
     C         ARAD   , DRAD                       )
      ENDIF
*
      CALL CLCEND( 'LEIVEC' )
*
      RETURN
      END
**********************************************************************
      SUBROUTINE LSTPHS                         !" $B2r@OBP>]J*M}NL$N@_Dj(B
     O         ( OATOR  , OAPOR  , OAT  )
*
      IMPLICIT NONE
*
*"  [OUTPUT]
      LOGICAL    OATOR                       !" $B%H%m%$%@%k2r@O%9%$%C%A(B
      LOGICAL    OAPOR                       !" $B%]%m%$%@%k2r@O%9%$%C%A(B
      LOGiCAL    OAT                         !" $B29EY2r@O%9%$%C%A(B
*
*"  [INTERNAL ONCE]
      LOGICAL    OTOR                        !" $B%H%m%$%@%k2r@O%9%$%C%A(B
      LOGICAL    OPOR                        !" $B%]%m%$%@%k2r@O%9%$%C%A(B
      LOGiCAL    OTEMP                       !" $B29EY2r@O%9%$%C%A(B
      DATA       OTOR  ,  OPOR  ,  OTEMP 
     &        / .TRUE. , .TRUE. , .TRUE. /
*
      NAMELIST   /NMLPHS/  OTOR , OPOR , OTEMP
*
*   [INTERNAL WORK]
      INTEGER    IFPAR, JFPAR
*
*"     < 1. $B2r@OBP>]J*M}NL$N@_Dj(B >
*
C      WRITE  ( JFPAR, NMLPHS )
      CALL   REWNML ( IFPAR , JFPAR )
      READ   ( IFPAR, NMLPHS , END=1190 )
 1190 WRITE  ( JFPAR, NMLPHS )
*
      OATOR = OTOR
      OAPOR = OPOR
      OAT   = OTEMP
*
      IF ( (.NOT.OATOR ) .OR. (.NOT. OAPOR ) .OR. (.NOT. OAT ) )THEN
         CALL MSGDMP( 'W', 'LSTPHS', 'ANALIZING RESTRICTED DYNAMICS' )
      ENDIF
*
      RETURN
      END
