* PACKAGE DGFRC !" ϳ (ʻ)
*
*" [HIS] 93/06/25(takepiro)
*
**********************************************************************
      SUBROUTINE GRDFRC    !" (ʻ)
     M             ( GTUA  , GTVA  , GTWA  , 
     M               GTUT  , GTVT  , GTWT  , GTH  ,
     C               ALON  , DLON  , ALAT  , DLAT ,
     C               ARAD  , DRAD                    )
*
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
      INCLUDE   (ZHDIM)                      !" ʸ
#else
#include        "zcdim.F"                    !" ʻȿ
#include        "zhdim.F"                    !" ʸ
#endif
*
*   [MODIFY] 
      REAL       GTUA  ( IDIM, JDIM, 0:KDIM )  !" ưѲգ
      REAL       GTVA  ( IDIM, JDIM, 0:KDIM )  !" ̱ưѲ֣
      REAL       GTWA  ( IDIM, JDIM, 0:KDIM )  !" ľưѲ֣
*
      REAL       GTUT  ( IDIM, JDIM, 0:KDIM )  !" ή  գ
      REAL       GTVT  ( IDIM, JDIM, 0:KDIM )  !" ̰ή  ֣
      REAL       GTWT  ( IDIM, JDIM, 0:KDIM )  !" ٱľή  ף
      REAL       GTH   ( IDIM, JDIM, 0:KDIM )  !" ٻѲ  
*
*   [INPUT]
      REAL       ALON  ( IDIM )               !" 
      REAL       DLON  ( IDIM )               !" ٲٽ
      REAL       ALAT  ( JDIM )               !" 
      REAL       DLAT  ( JDIM )               !" ٲٽ
      REAL       ARAD  ( 0:KDIM )             !" ٥()
      REAL       DRAD  ( 0:KDIM )             !" ()
*
*   [INTERNAL SAVE]
      REAL       FRCU ( IDIM, JDIM , 0:KDIM )  !"  ƣ
      REAL	 FRCV ( IDIM, JDIM , 0:KDIM )  !"  ƣ
      REAL       FRCW ( IDIM, JDIM , 0:KDIM )  !"  ƣ
*
      REAL       FLUT ( IDIM, JDIM , 0:KDIM )  !"  գ
      REAL	 FLVT ( IDIM, JDIM , 0:KDIM )  !"  ֣
      REAL       FLWT ( IDIM, JDIM , 0:KDIM )  !"  ף
*
      REAL       FHT  ( IDIM, JDIM , 0:KDIM )  !"  
*
      SAVE       FRCU , FRCV , FRCW , 
     &           FLUT , FLVT , FLWT , FHT
*
*   [INTERNAL WORK] 
      REAL       Z  , PI
      INTEGER    I, J , K
*
*   [INTERNAL PARM] 
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
*
*"         < 1.  η׻ >
*
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         WRITE ( 6,* ) ' STEADY FORCING:  DATE=93/07/14'
*
         PI = 4.* ATAN(1.0D0)
         DO 100 K = 0, KDIM
            Z = ( ARAD(K) - ARAD(0) )/ ( ARAD(KDIM)-ARAD(0) )
            DO 100 J = 1, JDIM
               DO 100 I = 1, IDIM
*
                  FRCU(I,J,K)  = 0. 
                  FRCV(I,J,K)  = 0. 
                  FRCW(I,J,K)  = 0. 
                  FLUT(I,J,K)  = 0.
                  FLVT(I,J,K)  = 0.
                  FLWT(I,J,K)  = 0.
                  FHT( I,J,K ) = SIN( 2*PI*Z ) 
     &                            * EXP( - ( 6 * ALAT(J)/PI )**2 )
 100     CONTINUE 
      ENDIF
*
*"         < 2. ʻѲ >
*
      DO 1100 K = 0, KDIM
         DO 1100 J = 1, JDIM
            DO 1100 I = 1, IDIM
               GTUA( I,J,K ) = GTUA( I,J,K ) +  FRCU( I,J,K )
               GTVA( I,J,K ) = GTVA( I,J,K ) +  FRCV( I,J,K )
               GTWA( I,J,K ) = GTWA( I,J,K ) +  FRCW( I,J,K )
*
               GTUT( I,J,K ) = GTUT( I,J,K ) +  FLUT( I,J,K )
               GTVT( I,J,K ) = GTVT( I,J,K ) +  FLVT( I,J,K )
               GTWT( I,J,K ) = GTWT( I,J,K ) +  FLWT( I,J,K )
               GTH ( I,J,K ) = GTH ( I,J,K ) +  FHT ( I,J,K )
 1100 CONTINUE

      RETURN
      END
